%{?!lua_compat_version: %global lua_compat_version 5.1}
%{?!lua_compat_pkgdir: %global lua_compat_pkgdir %{_datadir}/lua/%{lua_compat_version}}
%{?!lua_compat_libdir: %global lua_compat_libdir %{_libdir}/lua/%{lua_compat_version}}
%{?!lua_compat_includedir: %global lua_compat_includedir %{_includedir}/lua-%{lua_compat_version}}

%global luapkgname compat53

Name:           lua-%{luapkgname}
Version:        0.10
Release:        %mkrel 3
Summary:        Compatibility module providing Lua-5.3-style APIs for Lua %{lua_compat_version}
License:        MIT
Group:          Development/Other
URL:            https://github.com/keplerproject/lua-compat-5.3
Source0:        https://github.com/keplerproject/lua-compat-5.3/archive/v%{version}/%{name}-%{version}.tar.gz
BuildRequires:  gcc
BuildRequires:  pkgconfig
BuildRequires:  lua%{lua_compat_version}-devel

%description
This is a small module that aims to make it easier to write code in a
Lua-5.3-style that is compatible with Lua 5.1, Lua 5.2, and Lua 5.3. This does
not make Lua 5.2 (or even Lua 5.1) entirely compatible with Lua 5.3, but it
brings the API closer to that of Lua 5.3.

%package -n lua%{lua_compat_version}-%{luapkgname}
Summary:        Compatibility module providing Lua-5.3-style APIs for Lua %{lua_compat_version}
Requires:       lua(abi) = %{lua_compat_version}

%description -n lua%{lua_compat_version}-%{luapkgname}
This is a small module that aims to make it easier to write code in a
Lua-5.3-style that is compatible with Lua 5.1, Lua 5.2, and Lua 5.3. This does
not make Lua 5.2 (or even Lua 5.1) entirely compatible with Lua 5.3, but it
brings the API closer to that of Lua 5.3.

%package -n lua%{lua_compat_version}-bit32
Summary:	Lua 5.2 bit manipulation library for lua %{lua_compat_version}

%description -n lua%{lua_compat_version}-bit32
bit32 is the native Lua 5.2 bit manipulation library. It is compatible with Lua
5.1, 5.2 and 5.3.

%package -n lua%{lua_compat_version}-%{luapkgname}-devel
Summary:        Development files for lua %{lua_compat_version} compat53 module

%description -n lua%{lua_compat_version}-%{luapkgname}-devel
Development files for lua %{lua_compat_version} compat53 module

%prep
%setup -q -n lua-compat-5.3-%{version}

%build
CFLAGS="%{?optflags} -fPIC $(pkg-config --cflags lua-%{lua_compat_version})"
LDFLAGS="%{?build_ldflags}"
LIBS="$(pkg-config --libs lua-%{lua_compat_version})"

gcc $CFLAGS -c lutf8lib.c -o lutf8lib.o
gcc $CFLAGS -c lstrlib.c -o lstrlib.o
gcc $CFLAGS -c ltablib.c -o ltablib.o
gcc $CFLAGS -DLUA_COMPAT_BITLIB -c lbitlib.c -o lbitlib.o

gcc -shared $LDFLAGS -o utf8.so lutf8lib.o $LIBS
gcc -shared $LDFLAGS -o string.so lstrlib.o $LIBS
gcc -shared $LDFLAGS -o table.so ltablib.o $LIBS
gcc -shared $LDFLAGS -o bit32.so lbitlib.o $LIBS

%install
PKGDIR=%{buildroot}/%{lua_compat_pkgdir}
LIBDIR=%{buildroot}/%{lua_compat_libdir}

install -d -m 0755 "$PKGDIR/%{luapkgname}"
install -d -m 0755 "$LIBDIR/%{luapkgname}"
install -p -m 0644 %{luapkgname}/{init,module}.lua -t "$PKGDIR/%{luapkgname}/"
install -p -m 0755 {utf8,string,table}.so -t "$LIBDIR/%{luapkgname}/"
install -p -m 0755 bit32.so -t "$LIBDIR/"

install -d -m 0755 %{buildroot}%{lua_compat_includedir}/c-api
install -m 0644 -p -t %{buildroot}%{lua_compat_includedir}/c-api c-api/*
install -m 0644 lprefix.h %{buildroot}%{lua_compat_includedir}/lprefix.h

%files -n lua%{lua_compat_version}-%{luapkgname}
%license LICENSE
%doc README.md
%{lua_compat_pkgdir}/%{luapkgname}/
%{lua_compat_libdir}/%{luapkgname}/

%files -n lua%{lua_compat_version}-bit32
%license LICENSE
%doc README.md
%{lua_compat_libdir}/bit32.so

%files -n lua%{lua_compat_version}-%{luapkgname}-devel
%license LICENSE
%doc README.md
%{lua_compat_includedir}/*


%changelog
* Thu Jun 26 2025 umeabot <umeabot> 0.10-3.mga10
+ Revision: 2196609
- Mageia 10 Mass Rebuild

* Sat Mar 19 2022 umeabot <umeabot> 0.10-2.mga9
+ Revision: 1799849
- Mageia 9 Mass Rebuild

* Sun Jul 04 2021 wally <wally> 0.10-1.mga9
+ Revision: 1734725
- new version 0.10

* Sat Apr 03 2021 wally <wally> 0.9-2.mga9
+ Revision: 1713021
- add bit32 module

* Sat Apr 03 2021 wally <wally> 0.9-1.mga9
+ Revision: 1712999
- new version 0.9
- clean and mageiafy .spec
- Import from Fedora


* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Sep 16 2019 Andreas Schneider <asn@redhat.com> - 0.7-3
- Also package the c-api

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Wed Apr 03 2019 Tomas Krizek <tomas.krizek@nic.cz> - 0.7-1
- Initial package for Fedora 28+ and EPEL 7
